'Originally written for the Acorn Archimedes then converted to Microsoft
'QuickBasic and expanded with help & instructions added in July 2000 by
'Robert Goddard.
'Traditional BASIC gosub/return structure retained for ease of conversion

start:
DECLARE SUB COLOUR (front%, back%)
DECLARE SUB DEFWDW ()
DECLARE SUB display (la%, lb%, la$)
DECLARE SUB help (opp%, x%, y%)
DECLARE SUB sprite (x%, y%, z%, array%)
DECLARE SUB PLINT (text$)
DECLARE SUB PrintHelp (q$)

DECLARE FUNCTION keycheck! (z%)
DECLARE FUNCTION invhex% (temp$)

DIM SHARED a$, BACKGROUND, c$, d$, e%(99), o%(99), n%, p%
SCREEN 12: CALL DEFWDW: RANDOMIZE TIMER

a$ = "bcdefghijklnop O QRA.*5"
c$ = "12345679ABCDEF F08F088F"
d$ = "00000000000000 00088000"

'codes used in program
'0-3 = edges
'  4 = no atom (blank square on board)
'  5 = atom
' 16 = blank square

'COLOURS:-
'0 Black
'1 Blue
'2 Green
'3 Cyan
'4 Red
'5 Magenta
'6 Brown
'7 White
'8 Gray
'9 Light Blue
'10 Light green
'11 Light cyan
'12 Light red
'13 Light magenta
'14 Yellow
'15 High-intensity White

GOSUB scrub: RESTORE
DATA-10,1,10,-1,-11,-9,11,9,-9,11,9,-11
DIM a%(3), L%(3), R%(3): FOR T% = 0 TO 3: READ a%(T%): NEXT
FOR T% = 0 TO 3: READ L%(T%): NEXT: FOR T% = 0 TO 3: READ R%(T%): NEXT
DIM T%(99)
GOSUB atoms: GOSUB who
IF y% = 5 THEN GOSUB place ELSE GOSUB opponent
GOSUB edges: GOSUB board: GOSUB spots: GOSUB heading
z% = 0: S% = 0: p% = 0: x% = 0: y% = 9
h% = x%: v% = y%
DO
 GOSUB onx
 h% = x%: v% = y%
 CALL help(opp%, x%, y%)
 q% = keycheck(0): IF q% = 1000 THEN CLEAR : GOTO start
 IF q% = 32 THEN GOSUB space:  q% = 0
 IF q% = -77 THEN x% = x% + 1: IF x% = 10 THEN x% = 9
 IF q% = -80 THEN y% = y% + 1: IF y% = 10 THEN y% = 9
 IF q% = -75 THEN x% = x% - 1: IF x% = -1 THEN x% = 0
 IF q% = -72 THEN y% = y% - 1: IF y% = -1 THEN y% = 0
 GOSUB offx
LOOP
END

ray:
Lx% = x% + y% * 10: d% = o%(Lx%)
IF -T%(Lx% + a%(d%)) THEN GOSUB Black: GOSUB scor: RETURN
IF -T%(Lx% + L%(d%)) OR -T%(Lx% + R%(d%)) THEN GOSUB white: GOSUB scor: RETURN
Lx% = Lx% + a%(d%)
DO
 L% = -T%(Lx% + L%(d%)): K% = -T%(Lx% + a%(d%)): R% = -T%(Lx% + R%(d%))
 IF K% THEN GOSUB Black: EXIT DO
 IF L% AND R% THEN GOSUB white: EXIT DO
 IF L% THEN d% = d% + 1 + 4 * (d% = 3)
 IF R% THEN d% = d% - 1 - 4 * (d% = 0)
 Lx% = Lx% + a%(d%): IF o%(Lx%) < 4 THEN GOSUB hue: EXIT DO
LOOP
GOSUB scor
RETURN

white:
S% = S% + 1: CALL sprite(x%, y%, 18, -1)
o%(x% + y% * 10) = 6: GOSUB onx
RETURN

Black:
S% = S% + 1: CALL sprite(x%, y%, 19, -1)
o%(x% + y% * 10) = 6: GOSUB onx
RETURN

finish:
GOSUB offx
FOR x% = 1 TO 8: FOR y% = 1 TO 8
 IF -T%(x% + y% * 10) THEN
  CALL sprite(x%, y%, 22 + 7 * (o%(x% + y% * 10) = 5), -1)
  IF o%(x% + y% * 10) <> 5 THEN S% = S% + 5
 END IF
NEXT: NEXT
GOSUB scor
DO
 q$ = "Press Space Bar to play again or Esc to exit program."
 CALL PrintHelp(q$)
 look% = keycheck(0): IF look% = 1000 THEN CLEAR : GOTO start
 IF look% <> 32 THEN EXIT DO
LOOP
DO
 q$ = "Press Space Bar to play again or Esc to exit program."
 CALL PrintHelp(q$)
 look% = keycheck(0): IF look% = 1000 THEN CLEAR : GOTO start
 IF look% = 32 THEN EXIT DO
LOOP
RUN
RETURN

atoms:
CLS
CALL display(12, 1, "HOW MANY ATOMS DO YOU WANT? PRESS 4 or 5")
DO
 scan% = keycheck(0): IF scan% = 1000 THEN CLEAR : GOTO start
 n% = scan% - 48
 IF n% >= 4 AND n% <= 5 THEN EXIT DO
LOOP
RETURN

who:
CALL display(14, 1, "PLACED BY? PRESS C(omputer)or O(pponent)")
DO
 look% = keycheck(0): IF look% = 1000 THEN CLEAR : GOTO start
 IF look% = ASC("O") THEN y% = 6: EXIT DO
 IF look% = ASC("C") THEN y% = 5: EXIT DO
LOOP
RETURN

hue:
S% = S% + 2: Ly% = Lx% \ 10: Lx% = Lx% MOD 10
CALL sprite(x%, y%, z%, -1): CALL sprite(Lx%, Ly%, z%, -1)
o%(x% + y% * 10) = 6: o%(Lx% + Ly% * 10) = 6: GOSUB onx
z% = z% + 1
RETURN

outx:
CALL sprite(x%, y%, 16, -1)
o%(x% + y% * 10) = 4: p% = p% - 1: GOSUB onx
RETURN

tin:
IF p% = n% THEN
 lj% = 0
ELSE
 CALL sprite(x%, y%, 15, -1)
 o%(x% + y% * 10) = 5: p% = p% + 1: GOSUB onx
END IF
RETURN

inx:
IF p% = n% THEN
 REM
ELSE
 CALL sprite(x%, y%, 17, -1)
 o%(x% + y% * 10) = 5: p% = p% + 1: GOSUB onx
END IF
RETURN

onx:
COLOUR 15, 0
LINE ((24 + x% * 6) * 16 - 16 + 32 - 2, (32 - y% * 3) * 32 - 64 - 64)-((24 + x% * 6) * 16 - 16 - 3, (32 - y% * 3) * 32 - 65), , B
RETURN

offx:
COLOUR 0, 0
IF NOT (h% = x% AND v% = y%) THEN
 LINE ((24 + h% * 6) * 16 - 16 + 32 - 2, (32 - v% * 3) * 32 - 64 - 64)-((24 + h% * 6) * 16 - 16 - 3, (32 - v% * 3) * 32 - 65), , B
END IF
RETURN

edges:
FOR x% = 1 TO 8: FOR y% = 1 TO 8
 o%(x% + y% * 10) = 4
NEXT: NEXT
FOR c% = 1 TO 8
 o%(c% + 9 * 10) = 0: o%(0 + c% * 10) = 1
 o%(c% + 0 * 10) = 2: o%(9 + c% * 10) = 3
NEXT
o%(0) = 8: o%(90) = 8: o%(9) = 8: o%(99) = 8
RETURN

place:
FOR c% = 1 TO n%
 DO
  x% = INT((8) * RND + 1): y% = INT((8) * RND + 1)
  IF NOT (-T%(x% + y% * 10)) THEN EXIT DO
 LOOP
 T%(x% + y% * 10) = 1
NEXT
RETURN

space:
IF (x% = 9 AND y% = 9) AND p% = n% THEN GOSUB finish
u% = x% + y% * 10
IF o%(u%) <> 8 THEN
 DO
  IF o%(u%) = 4 THEN GOSUB inx: EXIT DO
  IF o%(u%) = 5 THEN GOSUB outx: EXIT DO
  IF o%(u%) < 4 THEN GOSUB ray: EXIT DO
  EXIT DO
 LOOP
 scan% = keycheck(0): IF scan% = 1000 THEN CLEAR : GOTO start
 IF scan% = ASC(" ") THEN
  DO
   look% = keycheck(0): IF look% = 1000 THEN CLEAR : GOTO start
   IF look% <> ASC(" ") THEN EXIT DO
  LOOP
 END IF
END IF
RETURN

spots:
FOR u% = 1 TO 8
 CALL sprite(u%, 0, 20, -1): CALL sprite(u%, 9, 20, -1)
 CALL sprite(0, u%, 20, -1): CALL sprite(9, u%, 20, -1)
NEXT
RETURN

heading:
COLOUR 7, 0: CALL display(11, 1, "SCORE"): S% = 0: GOSUB scor
RETURN

board:
CLS : COLOUR 15, 0: CALL display(2, 2, STR$(n%))
CALL display(5, 1, "ATOMS")
COLOUR 8, 0
FOR x% = 424 TO 1196 STEP 96
 FOR offset% = 0 TO 8 STEP 2
  LINE (x% + offset%, 104)-(x% + offset%, 884)
 NEXT
NEXT
FOR y% = 104 TO 876 STEP 96: FOR q% = 0 TO 12 STEP 2
 LINE (432, y% + q%)-(1195, y% + q%)
NEXT: NEXT
CALL sprite(9, 9, 21, -1)
RETURN

scor:
CALL display(14, 1, STR$(S%))
RETURN

opponent:
opp% = -1: 'flag shows we are in opponent section:used in help
GOSUB board: GOSUB spots: GOSUB edges: p% = 0: x% = 1: y% = 9
1580 GOSUB onx
h% = x%: v% = y%: q% = keycheck(0): IF q% = 1000 THEN CLEAR : GOTO start
IF q% = 32 THEN
 IF NOT (x% = 0 OR x% = 9 OR y% = 0 OR y% = 9) THEN
  lj% = -1: u% = x% + y% * 10
  IF o%(u%) = 4 THEN
   GOSUB tin
  ELSE
   IF o%(u%) = 5 THEN GOSUB outx
  END IF
  GOSUB offx
  IF p% = n% - 1 THEN GOSUB spots
  IF (p% = n%) AND lj% THEN GOSUB shoot
  DO: look% = keycheck(0): IF look% = 1000 THEN CLEAR : GOTO start
   IF look% <> ASC(" ") THEN EXIT DO
  LOOP
  GOTO 1580
 END IF
 IF x% = 9 AND y% = 9 AND (p% = n%) THEN
  GOSUB fill: GOSUB scrub: opp% = 0: RETURN
 END IF
END IF
CALL help(opp%, x%, y%)
IF q% = -77 THEN x% = x% + 1: IF x% = 10 THEN x% = 9
IF q% = -80 THEN y% = y% + 1: IF y% = 10 THEN y% = 9
IF q% = -75 THEN x% = x% - 1: IF x% = 0 THEN x% = 1
IF q% = -72 THEN y% = y% - 1: IF y% = 0 THEN y% = 1
GOSUB offx
GOTO 1580

scrub:
FOR x% = 0 TO 9: FOR y% = 0 TO 9
 e%(x% * 10 + y%) = 16
NEXT: NEXT
RETURN

fill:
CLS
FOR J% = 1 TO 8
 o%(J% + 9 * 10) = 0: o%(J% * 10) = 1: o%(J%) = 2: o%(9 + J% * 10) = 3
NEXT
FOR x% = 1 TO 8: FOR y% = 1 TO 8
 u% = x% + y% * 10
 IF o%(u%) = 4 THEN
  T%(u%) = 0
 ELSEIF o%(u%) = 5 THEN T%(u%) = 1
 END IF
NEXT: NEXT
RETURN

shoot:
FOR J% = 1 TO 8
 o%(J% + 9 * 10) = 0: o%(J% * 10) = 1: o%(J%) = 2: o%(9 + J% * 10) = 3
NEXT
z% = 0
FOR J% = 1 TO 8
 inx% = J%: iny% = 9: GOSUB fire
 inx% = 0: iny% = J%: GOSUB fire
 inx% = J%: iny% = 0: GOSUB fire
 inx% = 9: iny% = J%: GOSUB fire
NEXT
RETURN

fire:
Lx% = inx% + iny% * 10
d% = o%(Lx%)
IF d% = 6 THEN RETURN
IF o%(Lx% + a%(d%)) = 5 THEN GOSUB tack: RETURN
IF o%(Lx% + L%(d%)) = 5 OR o%(Lx% + R%(d%)) = 5 THEN GOSUB tite: RETURN
Lx% = Lx% + a%(d%)
DO
 L% = o%(Lx% + L%(d%)): K% = o%(Lx% + a%(d%)): R% = o%(Lx% + R%(d%))
 IF K% = 5 THEN GOSUB tack: RETURN
 IF L% = 5 AND R% = 5 THEN GOSUB tite: RETURN
 IF L% = 5 THEN
  d% = d% + 1 + 4 * (d% = 3)
 ELSEIF R% = 5 THEN
  d% = d% - 1 - 4 * (d% = 0)
 END IF
 Lx% = Lx% + a%(d%)
 IF o%(Lx%) < 4 THEN GOSUB tolor: RETURN
LOOP
RETURN

tack:
CALL sprite(inx%, iny%, 19, -1): o%(inx% + iny% * 10) = 6
RETURN

tite:
CALL sprite(inx%, iny%, 18, -1): o%(inx% + iny% * 10) = 6
RETURN

tolor:
Ly% = Lx% \ 10: Lx% = Lx% MOD 10
CALL sprite(inx%, iny%, z%, -1)
CALL sprite(Lx%, Ly%, z%, -1)
o%(inx% + iny% * 10) = 6: o%(Lx% + Ly% * 10) = 6: z% = z% + 1
RETURN

SUB COLOUR (front%, back%)
COLOR front%: BACKGROUND = back%
END SUB

SUB DEFWDW
WINDOW (0, 0)-(1279, 959)
END SUB

SUB display (cy%, cx%, u$)
WINDOW: h% = cx% * 8 - 8: v% = cy% * 16 - 16
FOR z% = 1 TO LEN(u$)
 COLOUR 15, 0: LOCATE 1, 1: PLINT MID$(u$, z%, 1)
 FOR y% = 0 TO 15 STEP 1
  FOR x% = 0 TO 7 STEP 1
   COLOUR POINT(x%, y%), 0
   LINE (h% + x% * 2 + (z% - 1) * 16, v% + y% * 2)-(h% + x% * 2 + (z% - 1) * 16 + 1, v% + y% * 2 + 1), , BF
  NEXT
 NEXT
NEXT
LOCATE 1, 1: PRINT " ": CALL DEFWDW
END SUB

SUB help (opp%, x%, y%)
IF opp% THEN
 IF (y% = 9 AND x% <> 9) OR x% = 9 THEN
   q$ = "Press arrow keys (not arrows on the number pad) to move white cursor box about."
 END IF
 IF (x% < 9 AND y% < 9) AND p% = n% THEN
  q$ = "Press arrow keys (not arrows on the number pad) to move white cursor box about."
 END IF
 IF x% = 9 AND y% = 9 THEN
  q$ = "Press Space Bar to finalise molecule, or arrows to move white cursor box about."
 END IF
 IF (x% < 9 AND y% < 9) AND (p% < n% AND o%(x% + y% * 10) <> 5) THEN
  q$ = "Press Space Bar to place an atom, or the arrows to move white cursor box about."
 END IF
 IF (x% < 9 AND y% < 9) AND o%(x% + y% * 10) = 5 THEN
  q$ = "Press SpaceBar to remove the atom,or the arrows to move white cursor box about."
 END IF
END IF
IF NOT opp% THEN
 q$ = "Press arrow keys (not arrows on the number pad) to move white cursor box about."
 IF ((x% = 0 OR x% = 9) OR (y% = 0 OR y% = 9)) AND (o%(x% + y% * 10) < 4) THEN
  q$ = "Press arrow keys to move the white cursor box about or Space Bar to fire a ray."
 END IF
 IF (x% = 0 AND y% = 0) OR (x% = 9 AND y% = 0) OR (x% = 0 AND y% = 9) THEN
  q$ = "Press arrow keys (not arrows on the number pad) to move white cursor box about."
 END IF
 IF (x% = 9 AND y% = 9) THEN
  q$ = "Press SpaceBar to finish molecule and calculate score or arrows to move cursor."
 END IF
 IF (x% < 9 AND y% < 9) AND (x% > 0 AND y% > 0) AND (p% < n% AND o%(x% + y% * 10) <> 5) THEN
  q$ = "Press Space Bar to place a trial atom,or arrows to move white cursor box about."
 END IF
 IF (x% < 9 AND y% < 9) AND (x% > 0 AND y% > 0) AND o%(x% + y% * 10) = 5 THEN
  q$ = "Press Space Bar to remove trial atom, or arrows to move white cursor box about."
 END IF
END IF
CALL PrintHelp(q$)
END SUB

FUNCTION invhex% (temp$)
IF temp$ >= "A" AND temp$ <= "F" THEN
 temp% = ASC(temp$) - 55
ELSE
 temp% = VAL(temp$)
END IF
invhex% = temp%
END FUNCTION

FUNCTION keycheck (z%) : ' see what keys have been pressed
i$ = UCASE$(INKEY$)
IF LEN(i$) > 1 THEN
 i% = -ASC(RIGHT$(i$, 1))
ELSEIF i$ <> "" THEN
 i% = ASC(i$)
ELSE
 i% = 0
END IF
IF i% = 27 THEN
 q$ = "Press the E key to exit the program, R to run a new game or C to continue on."
 CALL PrintHelp(q$)
 DO
  i$ = UCASE$(INKEY$)
  IF i$ = "C" THEN CALL PrintHelp(" "): EXIT DO
  IF i$ = "R" THEN i% = 1000: EXIT DO
  IF i$ = "E" THEN STOP
 LOOP
END IF
keycheck = i%
END FUNCTION

SUB PLINT (text$)
IF BACKGROUND = 0 THEN PRINT text$; : EXIT SUB
WINDOW
z% = POINT(0, 0): PSET (0, 0): fore% = POINT(0, 0): COLOR z%: PSET (0, 0)
h% = (POS(0) - 2) * 8: v% = (CSRLIN - 1) * 16
COLOR 1:  PRINT text$;
FOR z% = 1 TO LEN(text$)
 FOR y% = 0 TO 15
  FOR x% = 0 TO 7
   IF -POINT(h% + 7 - x% + z% * 8, v% + y%) THEN
    COLOR fore%
   ELSE
    COLOR BACKGROUND
   END IF
   PSET (h% + 7 - x% + z% * 8, v% + y%)
  NEXT
 NEXT
NEXT
CALL DEFWDW
END SUB

SUB plotprint (cy%, cx%, u$)
WINDOW
h% = cx% * 8 - 8: v% = cy% * 16 - 16
FOR z% = 1 TO LEN(u$)
 COLOUR 15, 0: LOCATE 1, 1: PLINT MID$(u$, z%, 1)
 FOR y% = 0 TO 15 STEP 1
  FOR x% = 0 TO 7 STEP 1
   COLOUR POINT(x%, y%), 0
   LINE (h% + x% * 2 + (z% - 1) * 16, v% + y% * 2)-(h% + x% * 2 + (z% - 1) * 16 + 1, v% + y% * 2 + 1), , BF
  NEXT
 NEXT
NEXT
CALL DEFWDW
END SUB

SUB PrintHelp (q$)
COLOR 15: LOCATE 30, 1: PRINT q$ + STRING$(79 - LEN(q$), " ");
END SUB

SUB sprite (x%, y%, z%, array%)
COLOUR invhex(MID$(c$, z% + 1, 1)), invhex(MID$(d$, z% + 1, 1))
LOCATE 1 + y% * 3, 24 + x% * 6: PLINT MID$(a$, z% + 1, 1)
FOR ox% = 30 TO 0 STEP -2
 FOR oy% = 62 TO 0 STEP -2
  COLOR POINT((24 + x% * 6) * 16 - 16 + ox% / 2, (32 - y% * 3) * 32 - 64 - oy% / 2)
  PSET ((24 + x% * 6) * 16 - 16 + ox%, (32 - y% * 3) * 32 - 64 - oy%)
 NEXT
NEXT
IF array% THEN e%(x% * 10 + y%) = z%
END SUB

